!  UTF-8 demonstration program
!  Phillip Carroll
!  Enabling Simplicity LLC

! Notes:  View this file in the C7 IDE in Consolas font for best results
! Don't save the file in the IDE or it will insert a signature that will break the file.
! Notepad2 was used to remove the signature while saving

					PROGRAM

					MAP
ValidUtf8           PROCEDURE(*STRING S,BYTE Single=0),BYTE  ! Returns TRUE or FALSE (1 or 0)
					END

     OMIT('*End of Table*')
Origin (English),Name (English),Origin (Native),Name (Native)
Australia,Nicole Kidman,Australia,Nicole Kidman
Austria,Johann Strauss,Österreich,Johann Strauß
Belgium (Flemish),Rene Magritte,België,René Magritte
Belgium (French),Rene Magritte,Belgique,René Magritte
Belgium (German),Rene Magritte,Belgien,René Magritte
Bhutan,Gonpo Dorji,འབྲུག་ཡུལ།,མགོན་པོ་རྡོ་རྗེ།
Canada,Celine Dion,Canada,Céline Dion
Canada - Nunavut (Inuktitut),Susan Aglukark,ᓄᓇᕗᒻᒥᐅᑦ,ᓱᓴᓐ ᐊᒡᓗᒃᑲᖅ
Democratic People's Rep. of Korea,LEE Sol-Hee,조선 민주주의 인민 공화국,이설희
Denmark,Soren Hauch-Fausboll,Danmark,Søren Hauch-Fausbøll
Denmark,Soren Kierkegaard,Danmark,Søren Kierkegård
Egypt,Abdel Halim Hafez,ﻣﺼﺮ,ﻋﺑﺪﺍﻠﺣﻟﻳﻢ ﺤﺎﻓﻅ
Egypt,Om Kolthoum,ﻣﺼﺮ,ﺃﻡ ﻛﻟﺛﻭﻡ
Eritrea,Berhane Zeray,ብርሃነ ዘርኣይ,ኤርትራ
Ethiopia,Haile Gebreselassie,ኃይሌ ገብረሥላሴ,ኢትዮጵያ
France,Gerard Depardieu,France,Gérard Depardieu
France,Jean Reno,France,Jean Réno
France,Camille Saint-Saens,France,Camille Saint-Saëns
France,Mylene Demongeot,France,Mylène Demongeot
France,Francois Truffaut,France,François Truffaut
France (Braille),Louis Braille,⠋⠗⠁⠝⠉⠑,⠇⠕⠥⠊⠎⠀<BR>⠃⠗⠁⠊⠇⠇⠑
Georgia,Eduard Shevardnadze,საქართველო,ედუარდ შევარდნაძე
Germany,Rudi Voeller,Deutschland,Rudi Völler
Germany,Walter Schultheiss,Deutschland,Walter Schultheiß
Greece,Giorgos Dalaras,Ελλάς,Γιώργος Νταλάρας
Iceland,Bjork Gudmundsdottir,Ísland,Björk Guðmundsdóttir
India (Hindi),Madhuri Dixit,भारत,माधुरी दिछित
Ireland,Sinead O'Connor,Éire,Sinéad O'Connor
Israel,Yehoram Gaon,ישראל,יהורם גאון
Italy,Fabrizio DeAndre,Italia,Fabrizio De André
Japan,KUBOTA Toshinobu,日本,久保田    利伸
Japan,HAYASHIBARA Megumi,日本,林原 めぐみ
Japan,Mori Ogai,日本,森鷗外
Japan,Tex Texin,日本,テクス テクサン
Norway,Tor Age Bringsvaerd,Noreg,Tor Åge Bringsværd
Pakistan (Urdu),Nusrat Fatah Ali Khan,پاکستان,نصرت فتح علی خان
People's Rep. of China,ZHANG Ziyi,中国,章子怡
People's Rep. of China,WONG Faye,中国,王菲
Poland,Lech Walesa,Polska,Lech Wałęsa
Puerto Rico,Olga Tanon,Puerto Rico,Olga Tañón
Rep. of China,Hsu Chi,臺灣,舒淇
Rep. of China,Ang Lee,臺灣,李安
Rep. of Korea,AHN Sung-Gi,한민국,안성기
Rep. of Korea,SHIM Eun-Ha,한민국,심은하
Russia,Mikhail Gorbachev,Россия,Михаил Горбачёв
Russia,Boris Grebenshchikov,Россия,Борис Гребенщиков
Slovenia,"Frane ""Jezek"" Milcinski",Slovenija,Frane Milčinski - Ježek
Syracuse (Sicily),Archimedes,Συρακούσα,Ἀρχιμήδης
Thailand,Thongchai McIntai,ประเทศไทย,ธงไชย แม็คอินไตย์
U.S.A.,Brad Pitt,U.S.A.,Brad Pitt
Yugoslavia (Cyrillic),Djordje Balasevic,Југославија,Ђорђе Балашевић
Yugoslavia (Latin),Djordje Balasevic,Jugoslavija,Đorđe Balašević
 *End of Table*

! Some things Unicode can do...
! Superscripts and subscripts:     U+2070...U+209F   U+00B2, U+00B3, U+00B9
!    Subscript Examples:  ₀₁₂₃₄₅₆₇₈₉₊₋₌₍₎ₐₑₒₓₔ  (H₂O)  
!    Superscript Examples:  ²³¹⁰ⁱ⁴⁵⁶⁷⁸⁹⁺⁻⁼⁽⁾ⁿ   (X², Xⁿ)      
! Arrows (U+2190 and following) : ←↑→↓↔↕↖↗↘↙ and many more
! (Arial Unicode MS also displays these in a variable width font)

! Some Egyptian text:
Egyptian   EQUATE('ﻣﺼﺮ,ﻋﺑﺪﺍﻠﺣﻟﻳﻢ ﺤﺎﻓﻅ')
! Russian Unicode characters in a Clarion string:
Utf8                STRING('Russia,Mikhail Gorbachev,Россия,Михаил Горбачёв')
S1                  STRING(200)
S2                  STRING(200)
S3                  STRING(200)
S4                  STRING(200)

window              WINDOW('Unicode Test'),AT(,,400,95),CENTER,FONT('Microsoft Sans Serif', 10,, FONT:regular, 54936)
						STRING(@S200), AT(62,10,330), USE(Utf8,, ?UTF1), FONT('Tahoma', 10,,,54936)
						STRING(@S200), AT(62,20,330), USE(S1), FONT('Tahoma', 10)
						STRING(@S200), AT(62,30,330), USE(S2), FONT('Tahoma', 10)
						STRING(@S200), AT(62,40,330), USE(S3), FONT('Tahoma', 10)
						STRING(@S200), AT(62,50,330), USE(S4), FONT('Tahoma', 10)
						BUTTON('OK'), AT(260,72), USE(?OK)
						STRING('If UTF-8 supported, all strings should display Cyrillic characters.'), AT(6,74), USE(?STRING1)
						STRING('Original string'), AT(6,10), USE(?STRING2)
						STRING('UPPER'), AT(6,20,41,10), USE(?STRING2:2)
						STRING('SUB(S,25,8)'), AT(6,30,41,10), USE(?STRING2:3)
						STRING('SLICE(S,25,32)'), AT(6,40,55,10), USE(?STRING2:4)
						STRING('ALL([slice],43)'), AT(6,50,55,10), USE(?STRING2:5)
					END

  INCLUDE('Unicode Functions.clw','Classes'),ONCE
UMgr               UTF8StringManager

N    LONG
	CODE
		IF NOT ValidUtf8(UTf8)     ! Test validity of a UTF-8 string using a Clarion validator function
		   Message('Russian string is NOT valid UTF8')
		END   
		S1 = Egyptian
		IF NOT ValidUtf8(S1)     ! Test validity of the Egyptian text
		   Message('Egyptian string is NOT valid UTF8')
		END   
		

	! examples of Clarion-source Unicode string functions (Unicode classes)
	! Get the Unicode value of the Cyrillic small letter che (U+0447): 	
	  N = UMgr.uVal('ч')         
    ! uChr method forms multibyte characters, given a Unicode code point value
    !  Test it with various code point binary bit boundaries:
	  S1 = UMgr.uChr(07FFh)     ! highest two-byte  code point
	  S1 = UMgr.uChr(0800h)     ! lowest three-byte 
	  S1 = UMgr.uChr(1000h)      
	  S1 = UMgr.uChr(2000h)      
	  S1 = UMgr.uChr(4000h)      
	  S1 = UMgr.uChr(8000h)     
	  S1 = UMgr.uChr(0FFFDh)    ! highest valid three-byte 
	  S1 = UMgr.uChr(10000h)    ! lowest four-byte

		S1 = 'Upper: ' & UPPER(utf8)  ! uppercase the ASCII part of a UTF-8 string - note the multibyte parts are unaffected
		
		UMgr.uSub(Utf8,25,8,S2)    ! Place into S2 the 8 character substring beginning with the 25th character of Utf8: ',Россия,'
		UMgr.uSlice(Utf8,25,32,S3) ! Place into S3 the slice UTf8[25:32]: ',Россия,'
		UMgr.uAll(S3,43,S4)        ! Fill a 43 character string with S3 and place into S4: 
		                           !  ',Россия,,Россия,,Россия,,Россия,,Россия,,Ро' 
		OPEN(window)
		ACCEPT
			IF ACCEPTED() = ?OK THEN BREAK.
		END	

! ====================================================================================
  INCLUDE('Unicode Functions.clw','ClassCode'),ONCE
  INCLUDE('Unicode Functions.clw','ValidityChecker'),ONCE
! =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

