

   MEMBER('test.clw')                                      ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('TEST001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('TEST002.INC'),ONCE        !Req'd for module callout resolution
                     END


Browse1 PROCEDURE                                          ! Generated from procedure template - Browse

BRW1::View:Browse    VIEW(Vault)
                       PROJECT(VAU:SID)
                       PROJECT(VAU:APPid)
                       PROJECT(VAU:OutDate)
                       PROJECT(VAU:InDate)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VAU:SID                LIKE(VAU:SID)                  !List box control field - type derived from field
VAU:APPid              LIKE(VAU:APPid)                !List box control field - type derived from field
VAU:OutDate            LIKE(VAU:OutDate)              !List box control field - type derived from field
VAU:InDate             LIKE(VAU:InDate)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  GRAY,MDI,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,FORMAT('60L(2)|M~SID~L(1)@n-14@60L(2)|M~APP id' & |
  '~L(1)@n-14@40L(2)|M~Out Date~L(1)@d1b@40L(2)|M~In Date~L(1)@d1b@'),FROM(Queue:Browse),IMM, |
  MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                       STRING('Tests ?List{{PropList: ..} properties'),AT(5,126),USE(?STRING1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Browse1')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Vault,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,VAU:VaultID)                          ! Add the sort order for VAU:VaultID for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,VAU:SID,1,BRW1)                ! Initialize the browse locator using  using key: VAU:VaultID , VAU:SID
  BRW1.AddField(VAU:SID,BRW1.Q.VAU:SID)                    ! Field VAU:SID is a hot field or requires assignment from browse
  BRW1.AddField(VAU:APPid,BRW1.Q.VAU:APPid)                ! Field VAU:APPid is a hot field or requires assignment from browse
  BRW1.AddField(VAU:OutDate,BRW1.Q.VAU:OutDate)            ! Field VAU:OutDate is a hot field or requires assignment from browse
  BRW1.AddField(VAU:InDate,BRW1.Q.VAU:InDate)              ! Field VAU:InDate is a hot field or requires assignment from browse
  INIMgr.Fetch('Browse1',BrowseWindow)                     ! Restore window settings from non-volatile store
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  END
  IF SELF.Opened
    INIMgr.Update('Browse1',BrowseWindow)                  ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateVault
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?List
    CASE EVENT()
    OF EVENT:AlertKey
        STOP('column ' & ?List{PROP:Column} & ' mouse down ' & ?List{PropList:MouseDownField} & |
      		' mouse up ' & ?List{PropList:MouseUpField} & ' Zone ' & ?List{PROPLIST:MouseDownZone} & | 
      		' row ' & ?List{PROPLIST:MouseDownRow} & ' Choice ' & CHOICE(?list))
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

UpdateVault PROCEDURE                                      ! Generated from procedure template - Form

ActionMessage        CSTRING(40)                           !
History::VAU:Record  LIKE(VAU:RECORD),THREAD
FormWindow           WINDOW('Update Records...'),AT(,,289,159),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  CENTER,GRAY,MDI,SYSTEM
                       PROMPT('Record ID'),AT(20,13),USE(?VAU:SID:Prompt)
                       ENTRY(@n-14),AT(70,12,60,10),USE(VAU:SID),RIGHT(1)
                       PROMPT('APP id:'),AT(20,28),USE(?VAU:APPid:Prompt)
                       ENTRY(@n-14),AT(70,27,60,10),USE(VAU:APPid),RIGHT(1)
                       PROMPT('Out Date:'),AT(21,48),USE(?VAU:OutDate:Prompt),LEFT
                       ENTRY(@d1),AT(71,47,60,10),USE(VAU:OutDate),LEFT,INS,MASK
                       PROMPT('In Date:'),AT(12,75),USE(?VAU:InDate:Prompt:2),LEFT
                       ENTRY(@d1),AT(62,74,60,10),USE(VAU:InDate,,?VAU:InDate:2),LEFT,INS,MASK
                       BUTTON('OK'),AT(5,140,40,12),USE(?OK),DEFAULT,REQ
                       BUTTON('Cancel'),AT(50,140,40,12),USE(?Cancel)
                       STRING(@S40),AT(95,140),USE(ActionMessage)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record will be Added'
  OF ChangeRecord
    ActionMessage = 'Record will be Changed'
  END
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateVault')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?VAU:SID:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(VAU:Record,History::VAU:Record)
  SELF.AddHistoryField(?VAU:SID,1)
  SELF.AddHistoryField(?VAU:APPid,2)
  SELF.AddHistoryField(?VAU:OutDate,3)
  SELF.AddHistoryField(?VAU:InDate:2,4)
  SELF.AddUpdateFile(Access:Vault)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Vault
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(FormWindow)                                    ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('UpdateVault',FormWindow)                   ! Restore window settings from non-volatile store
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateVault',FormWindow)                ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Main PROCEDURE                                             ! Generated from procedure template - Frame

AppFrame             APPLICATION('Browse Tests'),AT(,,395,281),FONT('Microsoft Sans Serif',10,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,MAX,STATUS(-1,80,120,45),SYSTEM,IMM
                       MENUBAR,USE(?MENUBAR1)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('P&rint Setup...'),USE(?PrintSetup),MSG('Setup Printer'),STD(STD:PrintSetup)
                           ITEM,USE(?SEPARATOR1),SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('Browse'),USE(?MENU3)
                           ITEM('Get Queue Record'),USE(?ITEM4)
                           ITEM('Test PropList Properties'),USE(?ITEM1)
                           ITEM('Limit PropList on Case KeyCode()'),USE(?ITEM2)
                           ITEM('Act only on Certain Columns'),USE(?ITEM3)
                           ITEM('Sort Header'),USE(?ITEM5)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Window'),USE(?MENU1),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?MENU2),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::MENUBAR1 ROUTINE                                     ! Code for menu items on ?MENUBAR1
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::MENU3 ROUTINE                                        ! Code for menu items on ?MENU3
  CASE ACCEPTED()
  OF ?ITEM4
    START(GetQueueRecord, 25000)
  OF ?ITEM1
    START(Browse1, 25000)
  OF ?ITEM2
    START(Browse2, 25000)
  OF ?ITEM3
    START(Browse3, 25000)
  OF ?ITEM5
    START(SortHeader, 25000)
  END
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::MENU1 ROUTINE                                        ! Code for menu items on ?MENU1
Menu::MENU2 ROUTINE                                        ! Code for menu items on ?MENU2

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  COMPILE ('**CW7**',_VER_C70)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::MENUBAR1                                    ! Process menu items on ?MENUBAR1 menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::MENU3                                       ! Process menu items on ?MENU3 menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::MENU1                                       ! Process menu items on ?MENU1 menu
      DO Menu::MENU2                                       ! Process menu items on ?MENU2 menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Browse2 PROCEDURE                                          ! Generated from procedure template - Browse

BRW1::View:Browse    VIEW(Vault)
                       PROJECT(VAU:SID)
                       PROJECT(VAU:APPid)
                       PROJECT(VAU:OutDate)
                       PROJECT(VAU:InDate)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VAU:SID                LIKE(VAU:SID)                  !List box control field - type derived from field
VAU:APPid              LIKE(VAU:APPid)                !List box control field - type derived from field
VAU:OutDate            LIKE(VAU:OutDate)              !List box control field - type derived from field
VAU:InDate             LIKE(VAU:InDate)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  GRAY,MDI,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,FORMAT('60L(2)|M~SID~L(1)@n-14@60L(2)|M~APP id' & |
  '~L(1)@n-14@40L(2)|M~Out Date~L(1)@d1b@40L(2)|M~In Date~L(1)@d1b@'),FROM(Queue:Browse),IMM, |
  MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                       STRING('Tests: Case ?List{{PropList:MouseDownField}'),AT(5,126),USE(?STRING1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Browse2')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Vault,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  ?List{Prop:LineHeight} = 0
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,VAU:VaultID)                          ! Add the sort order for VAU:VaultID for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,VAU:SID,1,BRW1)                ! Initialize the browse locator using  using key: VAU:VaultID , VAU:SID
  BRW1.AddField(VAU:SID,BRW1.Q.VAU:SID)                    ! Field VAU:SID is a hot field or requires assignment from browse
  BRW1.AddField(VAU:APPid,BRW1.Q.VAU:APPid)                ! Field VAU:APPid is a hot field or requires assignment from browse
  BRW1.AddField(VAU:OutDate,BRW1.Q.VAU:OutDate)            ! Field VAU:OutDate is a hot field or requires assignment from browse
  BRW1.AddField(VAU:InDate,BRW1.Q.VAU:InDate)              ! Field VAU:InDate is a hot field or requires assignment from browse
  INIMgr.Fetch('Browse2',BrowseWindow)                     ! Restore window settings from non-volatile store
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  END
  IF SELF.Opened
    INIMgr.Update('Browse2',BrowseWindow)                  ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateVault
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?List
    CASE EVENT()
    OF EVENT:AlertKey
      If KEYCODE() = MouseLeft2
      !  STOP('column ' & ?List{PROP:Column} & ' mouse down ' & ?List{PropList:MouseDownField} & |
      !   ' mouse up ' & ?List{PropList:MouseUpField} & ' Zone ' & ?List{PROPLIST:MouseDownZone})
        Case ?List{PropList:MouseDownField}
        Of 1
          Message('You selected the SID column')
        Of 2
          Message('You selected the AppID column')  
        Of 3
          Message('You selected the Out Date column')  
        Of 4
          Message('You selected the In Date column')    
        END
        Message('Did you see your selection?')
      End
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

Browse3 PROCEDURE                                          ! Generated from procedure template - Browse

BRW1::View:Browse    VIEW(Vault)
                       PROJECT(VAU:SID)
                       PROJECT(VAU:APPid)
                       PROJECT(VAU:OutDate)
                       PROJECT(VAU:InDate)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VAU:SID                LIKE(VAU:SID)                  !List box control field - type derived from field
VAU:APPid              LIKE(VAU:APPid)                !List box control field - type derived from field
VAU:OutDate            LIKE(VAU:OutDate)              !List box control field - type derived from field
VAU:InDate             LIKE(VAU:InDate)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  GRAY,MDI,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,FORMAT('60L(2)|M~SID~L(1)@n-14@60L(2)|M~APP id' & |
  '~L(1)@n-14@40L(2)|M~Out Date~L(1)@d1b@40L(2)|M~In Date~L(1)@d1b@'),FROM(Queue:Browse),IMM, |
  MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                       STRING('Tests: Case ?List{{PropList:MouseDownField} for fields 2, 3 and 4'),AT(5,126),USE(?STRING1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Browse3')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Vault,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  ?List{Prop:LineHeight} = 0
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,VAU:VaultID)                          ! Add the sort order for VAU:VaultID for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,VAU:SID,1,BRW1)                ! Initialize the browse locator using  using key: VAU:VaultID , VAU:SID
  BRW1.AddField(VAU:SID,BRW1.Q.VAU:SID)                    ! Field VAU:SID is a hot field or requires assignment from browse
  BRW1.AddField(VAU:APPid,BRW1.Q.VAU:APPid)                ! Field VAU:APPid is a hot field or requires assignment from browse
  BRW1.AddField(VAU:OutDate,BRW1.Q.VAU:OutDate)            ! Field VAU:OutDate is a hot field or requires assignment from browse
  BRW1.AddField(VAU:InDate,BRW1.Q.VAU:InDate)              ! Field VAU:InDate is a hot field or requires assignment from browse
  INIMgr.Fetch('Browse3',BrowseWindow)                     ! Restore window settings from non-volatile store
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  END
  IF SELF.Opened
    INIMgr.Update('Browse3',BrowseWindow)                  ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateVault
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?List
    CASE EVENT()
    OF EVENT:AlertKey
      If KEYCODE() = MouseLeft2
      !  Message('column ' & ?List{PROP:Column} & ' mouse down ' & ?List{PropList:MouseDownField} & |
      !   ' mouse up ' & ?List{PropList:MouseUpField} & ' Zone ' & ?List{PROPLIST:MouseDownZone})
        Case ?List{PropList:MouseDownField}
      ! Of 1
      !    Message('You selected the SID column')
        Of 2
          Message('You selected the AppID column. It would be easy to create a filter ' &|
          'on AppID ' & VAU:APPid)  
          Return Level:Notify
        Of 3
          Message('You selected the Out Date column. It would be easy to create a filter ' &|
          'on AppID ' & Format(VAU:OutDate,@d17))
          Return Level:Notify    
        Of 4
          Message('You selected the In Date column. It would be easy to create a filter ' &|
          'on AppID ' & Format(VAU:InDate,@d17))
          Return Level:Notify     
        END
       ! Message('Did you see your selection?')
      End
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

